Index: lib-index/mail-index-sync.c
===================================================================
RCS file: /var/lib/cvs/dovecot/src/lib-index/mail-index-sync.c,v
retrieving revision 1.69
diff -u -r1.69 mail-index-sync.c
--- lib-index/mail-index-sync.c	8 Feb 2006 17:29:05 -0000	1.69
+++ lib-index/mail-index-sync.c	23 Feb 2006 18:23:33 -0000
@@ -630,6 +630,7 @@
 
 	mail_index_view_close(&ctx->view);
 	mail_index_transaction_rollback(&ctx->trans);
+	array_free(&ctx->sync_list);
 	i_free(ctx);
 }
 
Index: lib-index/mail-index-view-sync.c
===================================================================
RCS file: /var/lib/cvs/dovecot/src/lib-index/mail-index-view-sync.c,v
retrieving revision 1.49
diff -u -r1.49 mail-index-view-sync.c
--- lib-index/mail-index-view-sync.c	14 Jan 2006 18:47:34 -0000	1.49
+++ lib-index/mail-index-view-sync.c	23 Feb 2006 18:23:33 -0000
@@ -530,8 +530,7 @@
 	i_assert(view->syncing);
 
 	*_ctx = NULL;
-	if (ctx->sync_map_update)
-		mail_index_sync_map_deinit(&ctx->sync_map_ctx);
+	mail_index_sync_map_deinit(&ctx->sync_map_ctx);
 	mail_index_view_sync_clean_log_syncs(ctx);
 
 	if (!ctx->last_read && ctx->hdr != NULL &&
Index: lib-storage/index/index-search.c
===================================================================
RCS file: /var/lib/cvs/dovecot/src/lib-storage/index/index-search.c,v
retrieving revision 1.108
diff -u -r1.108 index-search.c
--- lib-storage/index/index-search.c	14 Jan 2006 18:47:42 -0000	1.108
+++ lib-storage/index/index-search.c	23 Feb 2006 18:23:33 -0000
@@ -507,6 +507,7 @@
 			input = mail_get_stream(ctx->mail, NULL, NULL);
 			if (input == NULL)
 				return FALSE;
+			i_stream_ref(input);
 		} else {
 			/* FIXME: do this once in init */
 			i_assert(*headers != NULL);
@@ -538,6 +539,7 @@
 		if (input == NULL)
 			return FALSE;
 
+		i_stream_ref(input);
 		i_stream_seek(input, hdr_size.physical_size);
 	}
 
@@ -551,6 +553,7 @@
 
 		mail_search_args_foreach(args, search_body, &body_ctx);
 	}
+	i_stream_unref(&input);
 	return TRUE;
 }
 
